##// END OF EJS Templates
For buster images only...
vidal -
r203:46b63edc972c
parent child
Show More
@@ -1,653 +1,658
1 1 #!/bin/sh
2 2
3 3 ########################################################################
4 4 # rpi23-gen-image.sh 2015-2017
5 5 #
6 6 # Advanced Debian "jessie" and "stretch" bootstrap script for RPi2/3
7 7 #
8 8 # This program is free software; you can redistribute it and/or
9 9 # modify it under the terms of the GNU General Public License
10 10 # as published by the Free Software Foundation; either version 2
11 11 # of the License, or (at your option) any later version.
12 12 #
13 13 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
14 14 #
15 15 # Big thanks for patches and enhancements by 10+ github contributors!
16 16 ########################################################################
17 17
18 18 # Are we running as root?
19 19 if [ "$(id -u)" -ne "0" ] ; then
20 20 echo "error: this script must be executed with root privileges!"
21 21 exit 1
22 22 fi
23 23
24 24 # Check if ./functions.sh script exists
25 25 if [ ! -r "./functions.sh" ] ; then
26 26 echo "error: './functions.sh' required script not found!"
27 27 exit 1
28 28 fi
29 29
30 30 # Load utility functions
31 31 . ./functions.sh
32 32
33 33 # Load parameters from configuration template file
34 34 if [ ! -z "$CONFIG_TEMPLATE" ] ; then
35 35 use_template
36 36 fi
37 37
38 38 # Introduce settings
39 39 set -e
40 40 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
41 41 set -x
42 42
43 43 # Raspberry Pi model configuration
44 44 RPI_MODEL=${RPI_MODEL:=2}
45 45 RPI2_DTB_FILE=${RPI2_DTB_FILE:=bcm2709-rpi-2-b.dtb}
46 46 RPI2_UBOOT_CONFIG=${RPI2_UBOOT_CONFIG:=rpi_2_defconfig}
47 47 RPI3_DTB_FILE=${RPI3_DTB_FILE:=bcm2710-rpi-3-b.dtb}
48 48 RPI3_UBOOT_CONFIG=${RPI3_UBOOT_CONFIG:=rpi_3_32b_defconfig}
49 49
50 50 # Debian release
51 51 RELEASE=${RELEASE:=jessie}
52 52 KERNEL_ARCH=${KERNEL_ARCH:=arm}
53 53 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
54 54 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
55 55 COLLABORA_KERNEL=${COLLABORA_KERNEL:=3.18.0-trunk-rpi2}
56 56 if [ "$KERNEL_ARCH" = "arm64" ] ; then
57 57 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
58 58 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
59 59 else
60 60 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
61 61 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
62 62 fi
63 63 if [ "$RELEASE_ARCH" = "arm64" ] ; then
64 64 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
65 65 else
66 66 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
67 67 fi
68 68 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
69 69
70 70 # URLs
71 71 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
72 72 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
73 73 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm80211/brcm}
74 74 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
75 75 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
76 76 UBOOT_URL=${UBOOT_URL:=git://git.denx.de/u-boot.git}
77 77
78 78 # Build directories
79 79 BASEDIR=${BASEDIR:=$(pwd)/images/${RELEASE}}
80 80 BUILDDIR="${BASEDIR}/build"
81 81
82 82 # Prepare date string for default image file name
83 83 DATE="$(date +%Y-%m-%d)"
84 84 if [ -z "$KERNEL_BRANCH" ] ; then
85 85 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
86 86 else
87 87 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
88 88 fi
89 89
90 90 # Chroot directories
91 91 R="${BUILDDIR}/chroot"
92 92 ETC_DIR="${R}/etc"
93 93 LIB_DIR="${R}/lib"
94 94 BOOT_DIR="${R}/boot/firmware"
95 95 KERNEL_DIR="${R}/usr/src/linux"
96 96 WLAN_FIRMWARE_DIR="${R}/lib/firmware/brcm"
97 97
98 98 # Firmware directory: Blank if download from github
99 99 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
100 100
101 101 # General settings
102 102 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
103 103 PASSWORD=${PASSWORD:=raspberry}
104 104 USER_PASSWORD=${USER_PASSWORD:=raspberry}
105 105 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
106 106 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
107 107 EXPANDROOT=${EXPANDROOT:=true}
108 108
109 109 # Keyboard settings
110 110 XKB_MODEL=${XKB_MODEL:=""}
111 111 XKB_LAYOUT=${XKB_LAYOUT:=""}
112 112 XKB_VARIANT=${XKB_VARIANT:=""}
113 113 XKB_OPTIONS=${XKB_OPTIONS:=""}
114 114
115 115 # Network settings (DHCP)
116 116 ENABLE_DHCP=${ENABLE_DHCP:=true}
117 117
118 118 # Network settings (static)
119 119 NET_ADDRESS=${NET_ADDRESS:=""}
120 120 NET_GATEWAY=${NET_GATEWAY:=""}
121 121 NET_DNS_1=${NET_DNS_1:=""}
122 122 NET_DNS_2=${NET_DNS_2:=""}
123 123 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
124 124 NET_NTP_1=${NET_NTP_1:=""}
125 125 NET_NTP_2=${NET_NTP_2:=""}
126 126
127 127 # APT settings
128 128 APT_PROXY=${APT_PROXY:=""}
129 129 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
130 130
131 131 # Feature settings
132 132 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
133 133 ENABLE_I2C=${ENABLE_I2C:=false}
134 134 ENABLE_SPI=${ENABLE_SPI:=false}
135 135 ENABLE_IPV6=${ENABLE_IPV6:=true}
136 136 ENABLE_SSHD=${ENABLE_SSHD:=true}
137 137 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
138 138 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
139 139 ENABLE_SOUND=${ENABLE_SOUND:=true}
140 140 ENABLE_DBUS=${ENABLE_DBUS:=true}
141 141 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
142 142 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
143 143 ENABLE_XORG=${ENABLE_XORG:=false}
144 144 ENABLE_WM=${ENABLE_WM:=""}
145 145 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
146 146 ENABLE_USER=${ENABLE_USER:=true}
147 147 USER_NAME=${USER_NAME:="pi"}
148 148 ENABLE_ROOT=${ENABLE_ROOT:=false}
149 149
150 150 # SSH settings
151 151 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
152 152 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
153 153 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
154 154 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
155 155 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
156 156
157 157 # Advanced settings
158 158 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
159 159 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
160 160 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
161 161 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
162 162 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
163 163 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
164 164 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
165 165 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
166 166 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
167 167 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
168 168 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
169 169 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
170 170
171 171 # Kernel compilation settings
172 172 BUILD_KERNEL=${BUILD_KERNEL:=false}
173 173 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
174 174 KERNEL_THREADS=${KERNEL_THREADS:=1}
175 175 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
176 176 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
177 177 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
178 178 if [ "$KERNEL_ARCH" = "arm64" ] ; then
179 179 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
180 180 else
181 181 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
182 182 fi
183 183
184 184 # Kernel compilation from source directory settings
185 185 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
186 186 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
187 187 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
188 188 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
189 189
190 190 # Reduce disk usage settings
191 191 REDUCE_APT=${REDUCE_APT:=true}
192 192 REDUCE_DOC=${REDUCE_DOC:=true}
193 193 REDUCE_MAN=${REDUCE_MAN:=true}
194 194 REDUCE_VIM=${REDUCE_VIM:=false}
195 195 REDUCE_BASH=${REDUCE_BASH:=false}
196 196 REDUCE_HWDB=${REDUCE_HWDB:=true}
197 197 REDUCE_SSHD=${REDUCE_SSHD:=true}
198 198 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
199 199
200 200 # Encrypted filesystem settings
201 201 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
202 202 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
203 203 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
204 204 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
205 205 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
206 206
207 207 # Stop the Crypto Wars
208 208 DISABLE_FBI=${DISABLE_FBI:=false}
209 209
210 210 # Chroot scripts directory
211 211 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
212 212
213 213 # Packages required in the chroot build environment
214 214 APT_INCLUDES=${APT_INCLUDES:=""}
215 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils"
216
215 # apt-transport-https has been removed from repositories
216 # this induces qemu error 383 which does not prevent building an image
217 if [ "$RELEASE" = "buster" ] ; then
218 APT_INCLUDES="${APT_INCLUDES},apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils"
219 else
220 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils"
221 fi
217 222 # Packages required for bootstrapping
218 223 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
219 224 MISSING_PACKAGES=""
220 225
221 226 # Packages installed for c/c++ build environment in chroot (keep empty)
222 227 COMPILER_PACKAGES=""
223 228
224 229 set +x
225 230
226 231 # Set Raspberry Pi model specific configuration
227 232 if [ "$RPI_MODEL" = 2 ] ; then
228 233 DTB_FILE=${RPI2_DTB_FILE}
229 234 UBOOT_CONFIG=${RPI2_UBOOT_CONFIG}
230 235 elif [ "$RPI_MODEL" = 3 ] ; then
231 236 DTB_FILE=${RPI3_DTB_FILE}
232 237 UBOOT_CONFIG=${RPI3_UBOOT_CONFIG}
233 238 BUILD_KERNEL=true
234 239 else
235 240 echo "error: Raspberry Pi model ${RPI_MODEL} is not supported!"
236 241 exit 1
237 242 fi
238 243
239 244 # Check if the internal wireless interface is supported by the RPi model
240 245 if [ "$ENABLE_WIRELESS" = true ] && [ "$RPI_MODEL" != 3 ] ; then
241 246 echo "error: The selected Raspberry Pi model has no internal wireless interface"
242 247 exit 1
243 248 fi
244 249
245 250 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
246 251 if [ ! -z "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
247 252 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
248 253 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
249 254 exit 1
250 255 fi
251 256 fi
252 257
253 258 # Build RPi2/3 Linux kernel if required by Debian release
254 259 if [ "$RELEASE" = "stretch" ] ; then
255 260 BUILD_KERNEL=true
256 261 fi
257 262
258 263 # Add packages required for kernel cross compilation
259 264 if [ "$BUILD_KERNEL" = true ] ; then
260 265 if [ "$KERNEL_ARCH" = "arm" ] ; then
261 266 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
262 267 else
263 268 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
264 269 fi
265 270 fi
266 271
267 272 # Add libncurses5 to enable kernel menuconfig
268 273 if [ "$KERNEL_MENUCONFIG" = true ] ; then
269 274 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses5-dev"
270 275 fi
271 276
272 277 # Stop the Crypto Wars
273 278 if [ "$DISABLE_FBI" = true ] ; then
274 279 ENABLE_CRYPTFS=true
275 280 fi
276 281
277 282 # Add cryptsetup package to enable filesystem encryption
278 283 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
279 284 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
280 285 APT_INCLUDES="${APT_INCLUDES},cryptsetup"
281 286
282 287 if [ -z "$CRYPTFS_PASSWORD" ] ; then
283 288 echo "error: no password defined (CRYPTFS_PASSWORD)!"
284 289 exit 1
285 290 fi
286 291 ENABLE_INITRAMFS=true
287 292 fi
288 293
289 294 # Add initramfs generation tools
290 295 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
291 296 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
292 297 fi
293 298
294 299 # Add device-tree-compiler required for building the U-Boot bootloader
295 300 if [ "$ENABLE_UBOOT" = true ] ; then
296 301 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler"
297 302 fi
298 303
299 304 # Check if root SSH (v2) public key file exists
300 305 if [ ! -z "$SSH_ROOT_PUB_KEY" ] ; then
301 306 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
302 307 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
303 308 exit 1
304 309 fi
305 310 fi
306 311
307 312 # Check if $USER_NAME SSH (v2) public key file exists
308 313 if [ ! -z "$SSH_USER_PUB_KEY" ] ; then
309 314 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
310 315 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
311 316 exit 1
312 317 fi
313 318 fi
314 319
315 320 # Check if all required packages are installed on the build system
316 321 for package in $REQUIRED_PACKAGES ; do
317 322 if [ "`dpkg-query -W -f='${Status}' $package`" != "install ok installed" ] ; then
318 323 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
319 324 fi
320 325 done
321 326
322 327 # If there are missing packages ask confirmation for install, or exit
323 328 if [ -n "$MISSING_PACKAGES" ] ; then
324 329 echo "the following packages needed by this script are not installed:"
325 330 echo "$MISSING_PACKAGES"
326 331
327 332 echo -n "\ndo you want to install the missing packages right now? [y/n] "
328 333 read confirm
329 334 [ "$confirm" != "y" ] && exit 1
330 335
331 336 # Make sure all missing required packages are installed
332 337 apt-get -qq -y install ${MISSING_PACKAGES}
333 338 fi
334 339
335 340 # Check if ./bootstrap.d directory exists
336 341 if [ ! -d "./bootstrap.d/" ] ; then
337 342 echo "error: './bootstrap.d' required directory not found!"
338 343 exit 1
339 344 fi
340 345
341 346 # Check if ./files directory exists
342 347 if [ ! -d "./files/" ] ; then
343 348 echo "error: './files' required directory not found!"
344 349 exit 1
345 350 fi
346 351
347 352 # Check if specified KERNELSRC_DIR directory exists
348 353 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
349 354 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
350 355 exit 1
351 356 fi
352 357
353 358 # Check if specified UBOOTSRC_DIR directory exists
354 359 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
355 360 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
356 361 exit 1
357 362 fi
358 363
359 364 # Check if specified FBTURBOSRC_DIR directory exists
360 365 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
361 366 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
362 367 exit 1
363 368 fi
364 369
365 370 # Check if specified CHROOT_SCRIPTS directory exists
366 371 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
367 372 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
368 373 exit 1
369 374 fi
370 375
371 376 # Check if specified device mapping already exists (will be used by cryptsetup)
372 377 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
373 378 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
374 379 exit 1
375 380 fi
376 381
377 382 # Don't clobber an old build
378 383 if [ -e "$BUILDDIR" ] ; then
379 384 echo "error: directory ${BUILDDIR} already exists, not proceeding"
380 385 exit 1
381 386 fi
382 387
383 388 # Setup chroot directory
384 389 mkdir -p "${R}"
385 390
386 391 # Check if build directory has enough of free disk space >512MB
387 392 if [ "$(df --output=avail ${BUILDDIR} | sed "1d")" -le "524288" ] ; then
388 393 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
389 394 exit 1
390 395 fi
391 396
392 397 set -x
393 398
394 399 # Call "cleanup" function on various signals and errors
395 400 trap cleanup 0 1 2 3 6
396 401
397 402 # Add required packages for the minbase installation
398 403 if [ "$ENABLE_MINBASE" = true ] ; then
399 404 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
400 405 fi
401 406
402 407 # Add required locales packages
403 408 if [ "$DEFLOCAL" != "en_US.UTF-8" ] ; then
404 409 APT_INCLUDES="${APT_INCLUDES},locales,keyboard-configuration,console-setup"
405 410 fi
406 411
407 412 # Add parted package, required to get partprobe utility
408 413 if [ "$EXPANDROOT" = true ] ; then
409 414 APT_INCLUDES="${APT_INCLUDES},parted"
410 415 fi
411 416
412 417 # Add dbus package, recommended if using systemd
413 418 if [ "$ENABLE_DBUS" = true ] ; then
414 419 APT_INCLUDES="${APT_INCLUDES},dbus"
415 420 fi
416 421
417 422 # Add iptables IPv4/IPv6 package
418 423 if [ "$ENABLE_IPTABLES" = true ] ; then
419 424 APT_INCLUDES="${APT_INCLUDES},iptables"
420 425 fi
421 426
422 427 # Add openssh server package
423 428 if [ "$ENABLE_SSHD" = true ] ; then
424 429 APT_INCLUDES="${APT_INCLUDES},openssh-server"
425 430 fi
426 431
427 432 # Add alsa-utils package
428 433 if [ "$ENABLE_SOUND" = true ] ; then
429 434 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
430 435 fi
431 436
432 437 # Add rng-tools package
433 438 if [ "$ENABLE_HWRANDOM" = true ] ; then
434 439 APT_INCLUDES="${APT_INCLUDES},rng-tools"
435 440 fi
436 441
437 442 # Add fbturbo video driver
438 443 if [ "$ENABLE_FBTURBO" = true ] ; then
439 444 # Enable xorg package dependencies
440 445 ENABLE_XORG=true
441 446 fi
442 447
443 448 # Add user defined window manager package
444 449 if [ -n "$ENABLE_WM" ] ; then
445 450 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
446 451
447 452 # Enable xorg package dependencies
448 453 ENABLE_XORG=true
449 454 fi
450 455
451 456 # Add xorg package
452 457 if [ "$ENABLE_XORG" = true ] ; then
453 458 APT_INCLUDES="${APT_INCLUDES},xorg"
454 459 fi
455 460
456 461 # Replace selected packages with smaller clones
457 462 if [ "$ENABLE_REDUCE" = true ] ; then
458 463 # Add levee package instead of vim-tiny
459 464 if [ "$REDUCE_VIM" = true ] ; then
460 465 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
461 466 fi
462 467
463 468 # Add dropbear package instead of openssh-server
464 469 if [ "$REDUCE_SSHD" = true ] ; then
465 470 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/openssh-server/dropbear/")"
466 471 fi
467 472 fi
468 473
469 474 # Configure kernel sources if no KERNELSRC_DIR
470 475 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
471 476 KERNELSRC_CONFIG=true
472 477 fi
473 478
474 479 # Configure reduced kernel
475 480 if [ "$KERNEL_REDUCE" = true ] ; then
476 481 KERNELSRC_CONFIG=false
477 482 fi
478 483
479 484 # Execute bootstrap scripts
480 485 for SCRIPT in bootstrap.d/*.sh; do
481 486 head -n 3 "$SCRIPT"
482 487 . "$SCRIPT"
483 488 done
484 489
485 490 ## Execute custom bootstrap scripts
486 491 if [ -d "custom.d" ] ; then
487 492 for SCRIPT in custom.d/*.sh; do
488 493 . "$SCRIPT"
489 494 done
490 495 fi
491 496
492 497 # Execute custom scripts inside the chroot
493 498 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
494 499 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
495 500 chroot_exec /bin/bash -x <<'EOF'
496 501 for SCRIPT in /chroot_scripts/* ; do
497 502 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
498 503 $SCRIPT
499 504 fi
500 505 done
501 506 EOF
502 507 rm -rf "${R}/chroot_scripts"
503 508 fi
504 509
505 510 # Remove c/c++ build environment from the chroot
506 511 chroot_remove_cc
507 512
508 513 # Remove apt-utils
509 514 if [ "$RELEASE" = "jessie" ] ; then
510 515 chroot_exec apt-get purge -qq -y --force-yes apt-utils
511 516 fi
512 517
513 518 # Generate required machine-id
514 519 MACHINE_ID=$(dbus-uuidgen)
515 520 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
516 521 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
517 522
518 523 # APT Cleanup
519 524 chroot_exec apt-get -y clean
520 525 chroot_exec apt-get -y autoclean
521 526 chroot_exec apt-get -y autoremove
522 527
523 528 # Unmount mounted filesystems
524 529 umount -l "${R}/proc"
525 530 umount -l "${R}/sys"
526 531
527 532 # Clean up directories
528 533 rm -rf "${R}/run/*"
529 534 rm -rf "${R}/tmp/*"
530 535
531 536 # Clean up files
532 537 rm -f "${ETC_DIR}/ssh/ssh_host_*"
533 538 rm -f "${ETC_DIR}/dropbear/dropbear_*"
534 539 rm -f "${ETC_DIR}/apt/sources.list.save"
535 540 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
536 541 rm -f "${ETC_DIR}/*-"
537 542 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
538 543 rm -f "${ETC_DIR}/resolv.conf"
539 544 rm -f "${R}/root/.bash_history"
540 545 rm -f "${R}/var/lib/urandom/random-seed"
541 546 rm -f "${R}/initrd.img"
542 547 rm -f "${R}/vmlinuz"
543 548 rm -f "${R}${QEMU_BINARY}"
544 549
545 550 # Calculate size of the chroot directory in KB
546 551 CHROOT_SIZE=$(expr `du -s "${R}" | awk '{ print $1 }'`)
547 552
548 553 # Calculate the amount of needed 512 Byte sectors
549 554 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
550 555 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
551 556 ROOT_OFFSET=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS})
552 557
553 558 # The root partition is EXT4
554 559 # This means more space than the actual used space of the chroot is used.
555 560 # As overhead for journaling and reserved blocks 25% are added.
556 561 ROOT_SECTORS=$(expr $(expr ${CHROOT_SIZE} + ${CHROOT_SIZE} \/ 100 \* 25) \* 1024 \/ 512)
557 562
558 563 # Calculate required image size in 512 Byte sectors
559 564 IMAGE_SECTORS=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS})
560 565
561 566 # Prepare image file
562 567 if [ "$ENABLE_SPLITFS" = true ] ; then
563 568 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=${TABLE_SECTORS}
564 569 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek=${FRMW_SECTORS}
565 570 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=${TABLE_SECTORS}
566 571 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek=${ROOT_SECTORS}
567 572
568 573 # Write firmware/boot partition tables
569 574 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
570 575 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
571 576 EOM
572 577
573 578 # Write root partition table
574 579 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
575 580 ${TABLE_SECTORS},${ROOT_SECTORS},83
576 581 EOM
577 582
578 583 # Setup temporary loop devices
579 584 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME-frmw.img)"
580 585 ROOT_LOOP="$(losetup -o 1M -f --show $IMAGE_NAME-root.img)"
581 586 else # ENABLE_SPLITFS=false
582 587 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=${TABLE_SECTORS}
583 588 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek=${IMAGE_SECTORS}
584 589
585 590 # Write partition table
586 591 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
587 592 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
588 593 ${ROOT_OFFSET},${ROOT_SECTORS},83
589 594 EOM
590 595
591 596 # Setup temporary loop devices
592 597 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME.img)"
593 598 ROOT_LOOP="$(losetup -o 65M -f --show $IMAGE_NAME.img)"
594 599 fi
595 600
596 601 if [ "$ENABLE_CRYPTFS" = true ] ; then
597 602 # Create dummy ext4 fs
598 603 mkfs.ext4 "$ROOT_LOOP"
599 604
600 605 # Setup password keyfile
601 606 touch .password
602 607 chmod 600 .password
603 608 echo -n ${CRYPTFS_PASSWORD} > .password
604 609
605 610 # Initialize encrypted partition
606 611 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
607 612
608 613 # Open encrypted partition and setup mapping
609 614 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
610 615
611 616 # Secure delete password keyfile
612 617 shred -zu .password
613 618
614 619 # Update temporary loop device
615 620 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
616 621
617 622 # Wipe encrypted partition (encryption cipher is used for randomness)
618 623 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count=$(blockdev --getsz "${ROOT_LOOP}")
619 624 fi
620 625
621 626 # Build filesystems
622 627 mkfs.vfat "$FRMW_LOOP"
623 628 mkfs.ext4 "$ROOT_LOOP"
624 629
625 630 # Mount the temporary loop devices
626 631 mkdir -p "$BUILDDIR/mount"
627 632 mount "$ROOT_LOOP" "$BUILDDIR/mount"
628 633
629 634 mkdir -p "$BUILDDIR/mount/boot/firmware"
630 635 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
631 636
632 637 # Copy all files from the chroot to the loop device mount point directory
633 638 rsync -a "${R}/" "$BUILDDIR/mount/"
634 639
635 640 # Unmount all temporary loop devices and mount points
636 641 cleanup
637 642
638 643 # Create block map file(s) of image(s)
639 644 if [ "$ENABLE_SPLITFS" = true ] ; then
640 645 # Create block map files for "bmaptool"
641 646 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
642 647 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
643 648
644 649 # Image was successfully created
645 650 echo "$IMAGE_NAME-frmw.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
646 651 echo "$IMAGE_NAME-root.img ($(expr \( ${TABLE_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
647 652 else
648 653 # Create block map file for "bmaptool"
649 654 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
650 655
651 656 # Image was successfully created
652 657 echo "$IMAGE_NAME.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
653 658 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant